package mvd.jester;

import mvd.jester.model.SystemSetup;
import mvd.jester.priority.EarliestDeadlineFirst;
import mvd.jester.priority.RateMonotonic;


/**
 * Hello world!
 *
 */
public class App {
    public static void main(String[] args) {
        SystemSetup.Builder builder = new SystemSetup.Builder().setNumberOfProcessors(8);
        TestEnvironment te = new TestEnvironment(builder, 30000);

        te.registerSchedulingAlgorithm(new RateMonotonic());
        te.registerSchedulingAlgorithm(new EarliestDeadlineFirst());

        // te.registerTest(mvd.jester.tests.SchmidMottok.class);
        // te.registerTest(mvd.jester.tests.MaiaBertogna.class);

        te.registerSimulator(mvd.jester.simulator.MaiaBertogna.class);
        te.registerSimulator(mvd.jester.simulator.SchmidMottok.class);


        te.runTests();

        // SystemSetup ss = builder.build();
        // builder.addTask(ss);
        // builder.addTask(ss);
        // ss.writeToFile("Test3.txt");
    }
}
