package mvd.jester;

import mvd.jester.priority.PriorityManager;

/**
 * PriorityPair
 */
public class Pair<T extends PairInterface> {
    private final PriorityManager priorityManager;
    private final T abstractValue;


    public Pair(PriorityManager priorityManager, T abstractValue) {
        this.abstractValue = abstractValue;
        this.priorityManager = priorityManager;
    }

    /**
     * @return the priorityManager
     */
    public PriorityManager getPriorityManager() {
        return priorityManager;
    }

    /**
     * @return the abstractValue
     */
    public T getAbstractValue() {
        return abstractValue;
    }

    public String getName() {
        return abstractValue.getName() + "_" + priorityManager.getName();
    }

}
