package mvd.jester.info;

/**
 * TerminationInfo
 */
public class TerminationInfo {

    private final long releaseTime;
    private final long deadline;
    private final long responseTime;
    private final long lateness;

    public TerminationInfo(long releaseTime, long deadline, long responseTime) {
        this.releaseTime = releaseTime;
        this.deadline = deadline;
        this.responseTime = responseTime;
        this.lateness = responseTime - deadline;
    }


    /**
     * @return the deadline
     */
    public long getDeadline() {
        return deadline;
    }

    /**
     * @return the lateness
     */
    public long getLateness() {
        return lateness;
    }

    /**
     * @return the releaseTime
     */
    public long getReleaseTime() {
        return releaseTime;
    }

    /**
     * @return the responseTime
     */
    public long getResponseTime() {
        return responseTime;
    }
}
