package mvd.jester.model;

import com.google.common.math.LongMath;

// import com.google.common.math.LongMath;

public class Segment {

    private final long jobWcet;
    private final long numberOfJobs;
    private final long taskletWcet;
    private final long numberOfTasklets;

    public Segment(long jobWcet, long numberOfJobs) {
        this.jobWcet = jobWcet;
        this.numberOfJobs = numberOfJobs;
        if (numberOfJobs == 1) {
            this.taskletWcet = this.jobWcet;
            this.numberOfTasklets = this.numberOfJobs;
        } else if (this.numberOfJobs > this.jobWcet) {
            this.taskletWcet = LongMath.gcd(jobWcet, numberOfJobs);
            this.numberOfTasklets = this.jobWcet * this.numberOfJobs / this.taskletWcet;
        } else {
            this.taskletWcet = numberOfJobs;
            this.numberOfTasklets = jobWcet;
        }
    }



    /**
     * @return the numberOfJobs
     */
    public long getNumberOfJobs() {
        return numberOfJobs;
    }

    /**
     * @return the jobWcet
     */
    public long getJobWcet() {
        return jobWcet;
    }

    /**
     * @return the numberOfTasklets
     */
    public long getNumberOfTasklets() {
        return numberOfTasklets;
    }

    /**
     * @return the taskletWcet
     */
    public long getTaskletWcet() {
        return taskletWcet;
    }
}
