package mvd.jester.model;

import static org.junit.jupiter.api.Assertions.assertTrue;
import com.google.common.math.LongMath;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

/**
 * SegmentTest
 */
public class TestSegment {

    @Test
    @DisplayName("Test if dynamic segments are constructed correctly.")
    public void testSegmentConstruction() {
        Segment s1 = new Segment(100, 10);
        Segment s2 = new Segment(9, 10);

        assertTrue(s1.getJobWcet() == 100);
        assertTrue(s1.getNumberOfJobs() == 10);
        assertTrue(s1.getNumberOfTasklets() == 100);
        assertTrue(s1.getTaskletWcet() == 10);

        assertTrue(s2.getJobWcet() == 9);
        assertTrue(s2.getNumberOfJobs() == 10);
        assertTrue(s2.getNumberOfTasklets() == 9 * 10 / LongMath.gcd(9, 10));
        assertTrue(s2.getTaskletWcet() == LongMath.gcd(9, 10));

    }
}
