package mvd.jester.priority;

import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.junit.jupiter.api.Assertions.assertTrue;
import java.util.HashSet;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import mvd.jester.model.Task;
import mvd.jester.simulator.internals.maiabertogna.TaskContext;

/**
 * TestEarliestDeadlineFirst
 */
public class TestEarliestDeadlineFirst {

    @Test
    @DisplayName("Test if priority manager returns the correct priority.")
    public void testPriority() {
        EarliestDeadlineFirst edf = new EarliestDeadlineFirst();
        Task t1 = new Task(100, new HashSet<>());
        Task t2 = new Task(200, new HashSet<>());

        TaskContext tc1 = new TaskContext(t1, 0);
        TaskContext tc2 = new TaskContext(t2, 0);

        assertThrows(RuntimeException.class, () -> edf.compare(t1, t2));
        assertTrue(edf.compare(tc1, tc2) < 0);
    }
}
