package mvd.jester.priority;

import static org.junit.jupiter.api.Assertions.assertTrue;
import java.util.HashSet;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import mvd.jester.model.Segment;
import mvd.jester.model.Task;
import mvd.jester.simulator.internals.maiabertogna.TaskContext;

/**
 * TestRateMonotonic
 */
public class TestRateMonotonic {

    @Test
    @DisplayName("Test if priority manager returns the correct priority.")
    public void testPriority() {
        RateMonotonic rm = new RateMonotonic();
        Task t1 = new Task(100, new HashSet<Segment>());
        Task t2 = new Task(200, new HashSet<Segment>());

        TaskContext tc1 = new TaskContext(t1, 0);
        TaskContext tc2 = new TaskContext(t2, 0);

        assertTrue(rm.compare(t1, t2) < 0);
        assertTrue(rm.compare(tc1, tc2) < 0);
    }
}
